Public Class Form1
    Private Sub Panel1_Paint(ByVal sender As System.Object, _
        ByVal e As System.Windows.Forms.PaintEventArgs) Handles Panel1.Paint

        Zeichnen(e.Graphics)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles Button1.Click

        Dim cPrintForm As New clsPrintForm(Me, , , , "ein Header")
        If CheckBox1.Checked Then
            ' Druckvorschau
            cPrintForm.Print(, , , True)
        Else
            ' Drucken
            Dim PrinterName As String = ""
            If PrinterFind(PrinterName) Then
                cPrintForm.Print(, , , , PrinterName)
            End If
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles Button2.Click

        ' Neuzeichnen erzwingen
        Panel1.Refresh()
    End Sub

    Private Function PrinterFind(ByRef PrinterName As String) As Boolean
        PrinterName = ""
        Using PD As New PrintDialog
            Dim Result As DialogResult = PD.ShowDialog
            If Result = Windows.Forms.DialogResult.Cancel Then
                Return False
            End If
            PrinterName = PD.PrinterSettings.PrinterName
            Return True
        End Using
    End Function

    Private Sub Zeichnen(ByVal Gr As Graphics)
        Dim Ft As New Font("Arial", 20)
        Gr.DrawRectangle(Pens.Blue, 10, 10, 115, 30)
        Dim s As String = Date.Now.ToString("HH:mm:ss")
        Gr.DrawString(s, Ft, Brushes.Beige, 10, 10)
    End Sub
End Class
